CLEAR

#DEFINE CREATE_NEW 1
#DEFINE CREATE_ALWAYS 2
#DEFINE OPEN_EXISTING 3
 
#DEFINE FILE_ATTRIBUTE_NORMAL 128
 
#DEFINE GENERIC_READ   0x80000000
#DEFINE GENERIC_WRITE  0x40000000
#DEFINE GENERIC_ALL    0x10000000
#DEFINE MAXIMUM_ALLOWED 0x02000000
#DEFINE STANDARD_RIGHTS_ALL 0x001F0000
 
#DEFINE FILE_SHARE_READ 1
#DEFINE FILE_SHARE_WRITE 2
#DEFINE FILE_SHARE_DELETE 4
#DEFINE INVALID_HANDLE_VALUE -1 

#DEFINE page_writeread 4
#DEFINE page_readwrite 4
#DEFINE file_map_read 4
#DEFINE file_map_write 2

#define GMEM_FIXED          0x0000
#define GMEM_MOVEABLE       0x0002
#define GMEM_NOCOMPACT      0x0010
#define GMEM_NODISCARD      0x0020
#define GMEM_ZEROINIT       0x0040
#define GMEM_MODIFY         0x0080
#define GMEM_DISCARDABLE    0x0100
#define GMEM_NOT_BANKED     0x1000
#define GMEM_SHARE          0x2000
#define GMEM_DDESHARE       0x2000
#define GMEM_NOTIFY         0x4000
#define GMEM_LOWER          GMEM_NOT_BANKED
#define GMEM_VALID_FLAGS    0x7F72
#define GMEM_INVALID_HANDLE 0x8000


DECLARE INTEGER CreateFileMapping IN kernel32.DLL INTEGER hFile, ;
        INTEGER lpFileMappingAttributes, INTEGER flProtect, ;
        INTEGER dwMaximumSizeHigh, INTEGER dwMaximumSizeLow, ;
        STRING lpName

DECLARE INTEGER GetLastError IN kernel32.DLL

DECLARE INTEGER MapViewOfFile IN kernel32.DLL ;
        INTEGER hFileMappingObject, INTEGER dwDesiredAccess, ;
        INTEGER dwFileOffsetHigh, INTEGER dwFileOffsetLow, ;
        INTEGER dwNumberofBytesToMap

DECLARE INTEGER UnmapViewOfFile IN kernel32.DLL ;
        INTEGER lpBaseAddress

DECLARE INTEGER CloseHandle IN kernel32.DLL INTEGER hObject

DECLARE INTEGER CreateFile IN kernel32;
        STRING lpFileName, INTEGER dwDesiredAccess,;
        INTEGER dwShareMode, INTEGER lpSecurityAttr,;
        INTEGER dwCreationDisp, INTEGER dwFlagsAndAttrs,;
        INTEGER hTemplateFile

DECLARE INTEGER SetClipboardData  IN WIN32API INTEGER uFormat, INTEGER hMem 


DECLARE INTEGER GlobalAlloc IN KERNEL32.DLL INTEGER, INTEGER 
DECLARE INTEGER GlobalLock IN WIN32API INTEGER
DECLARE INTEGER GlobalUnlock IN WIN32API INTEGER
DECLARE INTEGER GlobalFree IN WIN32API INTEGER

Declare INTEGE RtlMoveMemory IN win32api Integer dest, Integer src, Integer nsize 

DECLARE INTEGER OpenClipboard IN WIN32API INTEGER
DECLARE INTEGER CloseClipboard IN WIN32API
DECLARE LONG EmptyClipboard IN user32

LOCAL lcPath,lcAlias,lihFile,lcOutFile,lcPom,lihMap,lihMapV,lnSize,lnPointer,lihMem,llDal,;
      loExcel,loSheet,loWorkbook
LOCAL laDir(1)
lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

lcAlias=SYS(2015)
lcOutFile=lcPath+"test.txt"

USE (lcPath+"test.dbf") ALIAS (lcAlias) IN 0


SELECT (lcAlias)
IF FILE(lcOutFile) 
   DELETE FILE (lcOutFile)
ENDIF

COPY TO (lcOutFile) DELIMITED WITH TAB
USE
ADIR(laDir,lcOutFile)
lnSize=laDir(1,2)


STORE 0 TO lihMem,lihMapV,lihMap,lihFile
llDal=.T.

* Oteven suboru
lihFile=CreateFile(lcOutFile,;
            GENERIC_ALL,;
            FILE_SHARE_WRITE+FILE_SHARE_READ,;
            0,;
            OPEN_EXISTING,;
            FILE_ATTRIBUTE_NORMAL,;
            0)

IF lihFile=0
   llDal=.F.
   MESSAGEBOX("Nepodailo se otevt soubor")
ENDIF

* Vytvoen mapovanho souboru
IF llDal
   lihMap = CreateFileMapping (lihFile, 0, PAGE_READWRITE, 0, 0, NULL)
   IF lihMap=0
      llDal=.F.
      MESSAGEBOX("Nepodailo se vytvoit mapovn souboru")
   ENDIF
ENDIF

* Vytvoen nhledu na mapovan soubor
IF llDal
   lihMapV = mapviewoffile(lihMap, file_map_write, 0, 0, 0)
   IF lihMapV=0
      llDal=.F.
      MESSAGEBOX("Nepodailo se vytvoit nhled na  mapovan soubor")
   ENDIF
ENDIF

* Alokace pamti
IF llDal
   lihMem=GlobalAlloc(GMEM_MOVEABLE,lnSize)

   IF lihMem=0
      llDal=.F.
      MESSAGEBOX("Nepodailo se na alokovat potebnou pam")
   ENDIF
ENDIF

IF llDal
   lnPointer = GlobalLock(lihMem)

   IF lnPointer=0
      llDal=.F.
      MESSAGEBOX("Nepodailo se zamknout potebnou pam")
   ENDIF
ENDIF

IF llDal
   * Pesunut mapovanho souboru do pamti
   =RtlMoveMemory(lnPointer,lihMapV,lnSize)

   * Oteven clipboardu a jeho nastaven
   =OpenClipboard(0)
   =EmptyClipboard()
   =SetClipBoardData(1,lnPointer)
   =CloseClipboard()

   * Vloen do Excelu pomoc OLE
   loExcel=CREATEOBJECT("Excel.Application")
   loWorkbook=loExcel.Workbooks.Add()
   loWorkBook.ActiveSheet.Paste()
   loExcel.Visible=.T.
   loWorkbook=.NULL.
   loExcel=.NULL.


   GlobalUnlock(lihMem)
ENDIF

* Uvolnn vech alokovanch zdroj
IF lihMem>0
   =GlobalFree(lihMem)
ENDIF
IF lihMapV>0
   =UnmapViewOfFile (lihMapV)
ENDIF
IF lihMap>0
   =CloseHandle(lihMap)
ENDIF
IF lihFile>0
   =CloseHandle(lihFile) 
ENDIF
